#include "p79.h"

/* Return a pointer to a dynamically-allocated C string corresponding
to a blank-padded fixed-length Fortran string. */

char *
p79ftc(s,n)
char		*s;
int		n;
{
    char	*p;
    char	*q;

    p = (char*)malloc(n+1);
    if (p)
    {
	(void)memcpy(p,s,n);
	q = p + n;
	*q-- = '\0';
	while ((q >= p) && (*q == ' '))	/* change trailing blanks to NULs */
	    *q-- = '\0';
    }
    return (p);
}
