      SUBROUTINE  CHPRCY
C     (CHPRCY)
C     PROCEDURE (Check If Proper Cycle Was Found)
C     (23-OCT-84)
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       CNAMNX,      F4CLC,       SCANER,      SFTERR
C     EXTERNAL REFS       SQUEEZ
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      LOGICAL             F4CLC,       SCANER
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                CLABEL,      I,           KASE,        L
C     SETS                N2,          SWORD,       TWORD,       TYPE
C
      INTEGER             BUF(40),     I,           KASE,        L
      INTEGER             N2,          TWORD,       TYPE
      LOGICAL             CLABEL,      SWORD
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM01  /
C
      INTEGER             BYTE,        CC,          CCLABL
      INTEGER             CCMORE,      IN,          INDENT
      INTEGER             LLABL,       MLABL
      INTEGER             NHELD,       OUT
      INTEGER             UNDENT
      LOGICAL             EOF,         FIRST,       LABEL,       LAST
      LOGICAL             MORE
C
      COMMON / COM01  /   BYTE,        CC,          CCLABL
      COMMON / COM01  /   CCMORE,      EOF,         FIRST,       IN
      COMMON / COM01  /   INDENT,      LABEL,       LAST
      COMMON / COM01  /   LLABL,       MLABL,       MORE
      COMMON / COM01  /   NHELD
      COMMON / COM01  /   OUT,         UNDENT
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM03  /
C
      INTEGER             CASES,       CCINDX,      CCLOG,       CCLOGS
      INTEGER             LINDX,       LLOG
      INTEGER             MINDX,       NFND,        NONE
      INTEGER             NSTACK,      S1STAK,      SFNMBR
      LOGICAL             BLANK,       FOUND,       NOFLOW,      NONMBR
      LOGICAL             XLATED
C
      COMMON / COM03  /   BLANK,       CASES(39),   CCINDX,      CCLOG
      COMMON / COM03  /   CCLOGS(2),   FOUND,       LINDX
      COMMON / COM03  /   LLOG,        MINDX
      COMMON / COM03  /   NFND,        NOFLOW,      NONE,        NONMBR
      COMMON / COM03  /   NSTACK,      S1STAK(39),  SFNMBR
      COMMON / COM03  /   XLATED
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM05  /
C
      INTEGER             BLANKS,      LEFT,        LEVEL
      INTEGER             RIGHT,       S0,          S1,          STRCTS
      COMMON / COM05  /   BLANKS(92),  LEFT,        LEVEL
      COMMON / COM05  /   RIGHT,       S0,          S1
      COMMON / COM05  /   STRCTS(39)
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM07  /
C
      INTEGER             S1PNDG,      S2
      LOGICAL             EXITS,       FND,         OTHERS
C
      COMMON / COM07  /   EXITS(39),   FND,         OTHERS(39),  S1PNDG
      COMMON / COM07  /   S2
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM24  /
C
      INTEGER             FIND,        LOCATE,      SCAN
C
      COMMON / COM24  /   FIND,        LOCATE,      SCAN
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM25  /
C
      INTEGER             DEFINE,      DOCASE,      DOFOR,       DOWITH
      INTEGER             ELSEIF,      FOREVR,      IFELSE,      IFTHEN
      INTEGER             ONCE,        PROC,        UNTIL,       WHILE
C
      COMMON / COM25  /   DEFINE,      DOCASE,      DOFOR,       DOWITH
      COMMON / COM25  /   ELSEIF,      FOREVR,      IFELSE,      IFTHEN
      COMMON / COM25  /   ONCE,        PROC,        UNTIL,       WHILE
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM29  /
C
      INTEGER             LABELS,      LBLPTR,      MAXLAB
C
      COMMON / COM29  /   LABELS(199), LBLPTR(39,2),MAXLAB
C
C
      IF (.NOT.(.NOT.MORE)) GO TO 20001
      KASE=1
      GO TO 20002
20001 ASSIGN 20004 TO NPR001
      GO TO 30001
20004 IF (     SWORD .AND. .NOT.CLABEL) KASE=2
      IF (.NOT.SWORD .AND.      CLABEL) KASE=3
      IF (     SWORD .AND.      CLABEL) KASE=4
20002 CONTINUE
C
20003 NX0009=KASE
      IF (NX0009.LT.1.OR.NX0009.GT.4) GO TO 20009
      GO TO (20005,20006,20007,20008), NX0009
20005 NSTACK=LEVEL
      FND=.TRUE.
      GO TO 20010
20006 ASSIGN 20011 TO NPR002
      GO TO 30002
20011 GO TO 20010
20007 ASSIGN 20012 TO NPR003
      GO TO 30003
20012 GO TO 20010
20008 ASSIGN 20013 TO NPR003
      GO TO 30003
20013 ASSIGN 20014 TO NPR004
      GO TO 30004
20014 CONTINUE
20009 CONTINUE
C
20010 RETURN
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Check For '(Name)' NEXT)
30005 CALL CNAMNX
      GO TO 20016
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Check For S-Word and/or C-Label)
30001 ASSIGN 20015 TO NPR006
      GO TO 30006
20015 ASSIGN 20016 TO NPR005
      GO TO 30005
20016 IF (.NOT.(FND)) GO TO 20017
      CLABEL=.TRUE.
      ASSIGN 20020 TO NPR007
      GO TO 30007
20020 GO TO 20018
20017 CLABEL=.FALSE.
20018 CONTINUE
20019 GO TO 20004
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Check For S-Word)
30006 TWORD=0
      TYPE=0
      GO TO 20022
20021 IF (TWORD.NE.0 .OR. TYPE.EQ.4) GO TO 20023
20022 TYPE=TYPE+1
      NX0028=TYPE
      IF (NX0028.LT.1.OR.NX0028.GT.4) GO TO 20028
      GO TO (20024,20025,20026,20027), NX0028
20024 IF (SCANER(FIND,5HWHILE,5)) TWORD=WHILE
      GO TO 20029
20025 IF (SCANER(FIND,5HUNTIL,5)) TWORD=UNTIL
      GO TO 20029
20026 IF (SCANER(FIND,7HFOREVER,7)) TWORD=FOREVR
      GO TO 20029
20027 IF (SCANER(FIND,3HFOR,3)) TWORD=DOFOR
20028 CONTINUE
20029 GO TO 20021
20023 SWORD = TWORD.NE.0
      GO TO 20015
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Compare S-Word To Labeled Structure Type)
30004 FND = TWORD .EQ. STRCTS(NSTACK)
      IF (.NOT.FND) CALL SFTERR(1,
     X44H(Labeled and CYCLE structure types disagree))
      GO TO 20014
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Remove Blanks From 'Cycle' Label)
30007 CALL SQUEEZ(LEFT+1,RIGHT-1,BUF,LLABL)
      GO TO 20020
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Search Label Stack For Matching Label)
30003 NSTACK = 0
      GO TO 20031
20030 IF (FND .OR. (NSTACK .EQ. LEVEL)) GO TO 20032
20031 NSTACK = NSTACK + 1
      N2 = LBLPTR(NSTACK,1)
      L = LBLPTR(NSTACK,2)
      FND = (L .EQ. (LLABL+1)) .AND. F4CLC(LABELS,N2,BUF,1,
     XLLABL)
      GO TO 20030
C
20032 IF (.NOT.FND) CALL SFTERR(1,21H(CYCLE label unknown))
      GO TO NPR003, (20012,20013)
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Search Structure Stack Upward For Type Matching S-Word)
30002 IF (.NOT.(LEVEL.LE.0)) GO TO 20033
      CALL SFTERR(1,24H(CYCLE found at level 0))
      GO TO 20034
20033 I=0
      GO TO 20037
20036 IF (FND .OR. I.EQ.LEVEL) GO TO 20038
20037 NSTACK=LEVEL-I
      FND = TWORD .EQ. STRCTS(NSTACK)
      I=I+1
      GO TO 20036
20038 CONTINUE
20034 IF (.NOT.FND) CALL SFTERR(1,
     X38H(Cycled structure not found. Ignored.))
      GO TO 20011
C
      END
